/*******************************************************************
   	XLMATH.H
   	=========
 	Header file for XLMATH.DLL
 *******************************************************************/

#define MAX_TASK_DESC	30
#define MAX_ERROR_STRING 96

typedef enum
{
	XLM_NO_TASK,
	XLM_NO_MEMORY,
	XLM_MEMORY_ERROR,
	XLM_NOT_SQUARE,
	XLM_NULL_TASK,
	XLM_SMEM_ERROR,
	XLM_RMEM_ERROR
} XLM_ERROR;

typedef double				*NPREAL;
typedef double FAR 			*LPREAL;
typedef double FAR * FAR	*LPLPREAL;


/* --------------<XL type K Array Structure>---------------------- */

typedef struct fp
{
	WORD wRows;		// no rows
	WORD wCols;		// no columns
	double Data[1];		// wRows*wCols doubles
}FP;
typedef FP FAR 	*LPFP;

typedef struct td			// task descriptor
{
	HANDLE	hTask;			// handle to active task
	LPVOID	lpReturnBuffer;		// pointer to return buffer
//	OMEM_POOL	ReturnPool;	// task specific memory pool
//	OMEM_POOL	ScratchPool;	// task specific memory pool
} TD;
typedef TD		*NPTD;

/* ----------------<EXPORT function prototypes>------------------ */

LPFP PASCAL FAR _export Frequency(LPFP lpValues, LPFP lpBrackets);
LPFP PASCAL FAR _export Diagonalize(LPFP lpHmat);
LPFP PASCAL FAR _export PolyCurveFit(LPFP lpIndVar, LPFP lpDepVar,
					unsigned int Order);
LPFP PASCAL FAR _export CubicSplines(LPFP lpIndVar, LPFP lpDepVar);
LPREAL PASCAL FAR _export CalcSpline(LPFP lpIndVar, LPFP lpCoef, LPREAL lpX);
LPFP PASCAL FAR _export SmoothSG(LPFP lpData, unsigned int wSmoothNum,
							unsigned int wDerivNum);
LPFP PASCAL FAR _export SmoothWeights(LPFP lpData, LPFP lpWeights,
								LPREAL lpDivisor);

